//********Esta clase provee los metodos y variables miembro
//********para crear y cargar archivos RINEX


//definicion del archivo
#ifndef archivos_HPP
#define archivos_HPP

//Clases que permiten operaciones de entrada y salida en C++
#include<iostream>
#include<fstream>
#include<wx/string.h>

//Clases relacionadas con el manejo de observaciones RINEX

#include"RinexObsBase.hpp"
#include"RinexObsHeader.hpp"
#include"RinexObsData.hpp"
#include"RinexObsStream.hpp"

//Clases que permiten el manejo de parametros de navegacion
//satelital

#include"RinexNavBase.hpp"
#include"RinexNavHeader.hpp"
#include"RinexNavData.hpp"
#include"RinexNavStream.hpp"

//Clases relacionadas con el manejo de condiciones metereologicas

#include"RinexMetBase.hpp"
#include"RinexMetHeader.hpp"
#include"RinexMetData.hpp"
#include"RinexMetStream.hpp"


/*
//Clases que permiten el manejo de archivos de tipo SP3

#include"SP3Base.hpp"
#include"SP3Header.hpp"
#include"SP3Data.hpp"
#include"SP3Stream.hpp"
*/


using namespace std;
using namespace gpstk;

class Rinex
{
public:
  //*******Constructores de la clase**********
  
  //constructor
  Rinex();
  //destructor
  ~Rinex();

  //****Metodos de acceso

  //Cargue de archivos
  void CargarObs(wxString o);
  void CargarNav(wxString n);
  void CargarMet(wxString m);

  //void Cargar_SP3(char * sp3);

  //Creacion Archivos
  void CreacionObs(wxString o);
  void CreacionNav(wxString n);
  void CreacionMet(wxString m);

  //Escritura en archivos Creados
  void EscrituraObs();
  void EscrituraObs(wxString o);
  void EscrituraNav();
  void EscrituraNav(wxString n);
  void EscrituraMet();
  void EscrituraMet(wxString m);

  //SP3Stream Creacion_SP3(char * sp3);

  //Metodos de acceso
  string Saludo()
  {return saludo;}
  string Despedida()
  {return despedida;}
 
  //Acceso a los datos de los archivos
  RinexObsStream & ObtenerObservacionesRinex()
  {return aor;}
  RinexNavStream & ObtenerNavegacionesRinex()
  {return anr;}
  RinexMetStream & ObtenerMetereologiaRinex()
  {return amr;}

private:

  //Atributos que contienen Mensajes
  string saludo;
  string despedida;

  //*******Instanciaciones a los objetos que permiten acceder y trabajar con archivos Rinex********

  //Obsrvaciones RINEX
  RinexObsStream aor;
  RinexObsHeader cor;
  RinexObsStream salida_aor;
  RinexObsData dor;

  //Informacion de Navegacion
  RinexNavStream anr;
  RinexNavHeader cnr;
  RinexNavStream salidaAnr;
  RinexNavData dnr;

  //Informacion Metereologica
  RinexMetStream amr;
  RinexMetHeader cmr;
  RinexMetStream salidaAmr;
  RinexMetData dmr;

  /*
  //Efemerides precisas sp3
  SP3Stream esp3;
  SP3Header csp3;
  */

};



#endif
