//Llamadas al preproceador 
//Incluye la cabecera donde se declaro la clase
#include"gui.hpp"

//Implementacion de la tabla de eventos de la clase Ventana

BEGIN_EVENT_TABLE(Ventana, wxFrame)
    //Eventos asocidos a los botones
    EVT_MENU (wxID_EXIT, Ventana::BotonSalida)
    EVT_MENU (wxID_HELP,  Ventana::BotonAyuda)
    EVT_MENU (wxID_ABOUT, Ventana::BotonInformacion)

    //Eventos asociados a la barra de herramientas

    //Eventos asociados a los botondes dentro de la ventana
    EVT_BUTTON (wxID_OPEN,  Ventana::BotonCargueObservacionesBaseRinex)
    EVT_BUTTON (wxID_PRINT,  Ventana::BotonCargueNavegacionesBaseRinex)
    EVT_BUTTON (wxID_SAVEAS,  Ventana::BotonCargueMetereologiaBaseRinex)
    EVT_BUTTON (wxID_NEW,  Ventana::BotonCargueObservacionesRoverRinex)
    EVT_BUTTON (wxID_PRINT_SETUP,  Ventana::BotonCargueNavegacionesRoverRinex)
    EVT_BUTTON (wxID_REDO,  Ventana::BotonCargueMetereologiaRoverRinex)
    EVT_BUTTON (wxID_CLOSE, Ventana::BotonGuardarReporte)
    EVT_BUTTON (wxID_OK, Ventana::BotonProcesar)

END_EVENT_TABLE();


//Sentencia que permite el cargue de la aplicacion

IMPLEMENT_APP(Aplicacion)

bool Aplicacion::OnInit()
{
  Ventana* aptVentana = new Ventana(wxT("GUDUX"));

  aptVentana->Show(true);
  SetTopWindow(aptVentana);

  return true;
}

Ventana::Ventana(const wxString& tituloVentana):
  //Caracteristicas de la vantana
  wxFrame((wxFrame *)NULL, -1, tituloVentana, wxPoint(400,170), wxSize(700,700))
{

  wxImage::AddHandler(new wxPNGHandler);

  archivosRinexBase = new Rinex;
  archivosRinexRover = new Rinex;


  //Crea el menu Archivo
  wxMenu* aptMenuArchivo = new wxMenu;

  //Inserta comandos al menu archivo
  aptMenuArchivo->Append(wxID_EXIT, wxT("&Salir \tCtrl-w"));
  
  //Crea el menu Ayuda
  wxMenu* aptMenuAyuda = new wxMenu;

  //Inserta Comandos al menu ayuda
  aptMenuAyuda->Append(wxID_ABOUT, wxT("A&cerda de"));
  aptMenuAyuda->Append(wxID_HELP, wxT("A&yuda"));

  //Crea una barra donde van los diferentes menus
  wxMenuBar* aptBarraMenu = new wxMenuBar;


  wxToolBar *aptBarraHerramientas = new wxToolBar(this, wxID_ANY,wxPoint(0,2),wxSize(700, 20), wxTB_HORIZONTAL, wxT("wtbBarra1"));

  //*******************COORDENADAS DE LA BASE*******************

  //Crea un marco para encerrados los dos conjuntos de botones y cajas de texto de los datos de la base
  wxStaticBox* aptCajaMarcoCoordenadasBase = new wxStaticBox(this, wxID_ANY, wxT("Coordenadas de la Base"), wxPoint(10,55), wxSize(400, 132));

  //Crea los controles de texto para cargar los archivos RINEX de la Base
  aptCtrlTextoCoordenadaXBase = new wxTextCtrl(this, wxID_ANY, wxT("Coordenada X de la Base"), wxPoint(20,75), wxSize(250, 20));


  aptCtrlTextoCoordenadaYBase = new wxTextCtrl(this, wxID_ANY, wxT("Coordenada Y de la Base"), wxPoint(20,115), wxSize(250, 20));
  aptCtrlTextoCoordenadaZBase = new wxTextCtrl(this, wxID_ANY, wxT("Coordnedad Z de la Base"), wxPoint(20,155), wxSize(250, 20));



  //*******************DATOS DE LA BASE*******************

  //Crea un marco para encerrados los dos conjuntos de botones y cajas de texto de los datos de la base
  wxStaticBox* aptCajaMarcoControlesBase = new wxStaticBox(this, wxID_ANY, wxT("RINEX de la Base"), wxPoint(10,210), wxSize(400, 132));

  //Crea los controles de texto para cargar los archivos RINEX de la Base
  aptCtrlTextoObservacionesBaseRinex = new wxTextCtrl(this, wxID_ANY, wxT("Observaciones RINEX BASE"), wxPoint(20,230), wxSize(250, 20));


  aptCtrlTextoNavegacionesBaseRinex = new wxTextCtrl(this, wxID_ANY, wxT("Navegaciones RINEX BASE"), wxPoint(20,270), wxSize(250, 20));
  aptCtrlTextoMetereologiaBaseRinex = new wxTextCtrl(this, wxID_ANY, wxT("Metereología RINEX BASE"), wxPoint(20,310), wxSize(250, 20));

  //Crea los botones al lado de los controles de texto para buscar los archivos RINEX de la base
  aptBotonObsBaseRinex = new wxButton(this, wxID_OPEN, wxT("Obs"), wxPoint(280,230), wxSize(80, 25));
  aptBotonNavBaseRinex = new wxButton(this, wxID_PRINT, wxT("Nav"), wxPoint(280,270), wxSize(80, 25));
  aptBotonMetBaseRinex = new wxButton(this, wxID_SAVEAS, wxT("Met"), wxPoint(280,310), wxSize(80, 25));




  //***************DATOS DEL ROVER*************************

  //Crea un marco para encerrados los dos conjuntos de botones y cajas de texto de los datos del rover
  wxStaticBox *aptCajaMarcoControlesRover = new wxStaticBox(this, wxID_ANY , wxT("RINEX del Rover"), wxPoint(10,365), wxSize(400, 132));

  //Crea los controles de texto para cargar los archivos RINEX del Rover
  aptCtrlTextoObservacionesRoverRinex = new wxTextCtrl(this, wxID_ANY, wxT("Observaciones RINEX ROVER"), wxPoint(20,385), wxSize(250, 20));
  aptCtrlTextoNavegacionesRoverRinex = new wxTextCtrl(this, wxID_ANY, wxT("Navegaciones RINEX ROVER"), wxPoint(20,425), wxSize(250, 20));
  aptCtrlTextoMetereologiaRoverRinex = new wxTextCtrl(this, wxID_ANY, wxT("Metereología RINEX ROVER"), wxPoint(20,465), wxSize(250, 20));

  //Crea los botones al lado de los controles de texto para buscar los archivos RINEX del rover
  aptBotonObsRoverRinex = new wxButton(this, wxID_NEW, wxT("&Obs"), wxPoint(280,385), wxSize(80, 25));
  aptBotonNavRoverRinex = new wxButton(this, wxID_PRINT_SETUP, wxT("&Nav"), wxPoint(280, 425), wxSize(80, 25));
  aptBotonMetRoverRinex = new wxButton(this, wxID_REDO, wxT("&Met"), wxPoint(280, 465), wxSize(80, 25));


  //****************DATOS ARCHIVO DE SALIDA**************************************
  //Crea un marco para encerrados los dos conjuntos de botones y cajas de texto de los datos del rover
  wxStaticBox* aptCajaMarcoArchivoSalida = new wxStaticBox(this, wxID_ANY , wxT("Archivo Salida"), wxPoint(10,520), wxSize(400, 70));

  //Crea los controles de texto para cargar los archivos RINEX del Rover
  aptCtrlTextoArchivoSalida = new wxTextCtrl(this, wxID_ANY, wxT("/home/salida.log"), wxPoint(20,560), wxSize(250, 20));

  //Crea los botones al lado de los controles de texto para buscar los archivos RINEX del rover
  aptBotonArchivoSalida = new wxButton(this, wxID_CLOSE, wxT("Salida"), wxPoint(280,560), wxSize(80, 25));

  //Boton para ejecutar el postprocesamiento de los datos
  aptBotonProcesamiento = new wxButton(this, wxID_OK, wxT("Pro&cesar"), wxPoint(290,600), wxSize(70,30));


  //Inserta en la barra los diferentes widgets creados
  aptBarraMenu->Append(aptMenuArchivo, wxT("&Archivo"));
  aptBarraMenu->Append(aptMenuAyuda, wxT("A&yuda"));

  //******************Carga imagen****************************************************



  wxScrolledWindow* sw = new wxScrolledWindow(this);

  wxBitmap mapaBits(wxT("../bin/logo.png"), wxBITMAP_TYPE_PNG);

  wxStaticBitmap* mapaBitsStatico = new wxStaticBitmap(this, -1, mapaBits, wxPoint(417,25));
  int ancho = mapaBits.GetWidth();
  int altura = mapaBits.GetHeight();


  sw->SetScrollbars(10,10,ancho/10, altura/10);
  sw->Scroll(50,10);

  //Ajusta la barra de herramientas creada anteriormente ene el frame
  SetMenuBar(aptBarraMenu);

  //Crea una barra de estado dentro del frame
  CreateStatusBar(2);
  Center();
}


//*******Implementaciones***************

Ventana::~Ventana()
{
  delete archivosRinexBase;
  delete archivosRinexRover;
}


//******Botones para bucar archivos de la base**********
//BotonSalida
void Ventana::BotonSalida(wxCommandEvent& WXUNUSED(event))
{
  //Destruye la ventana
  Close(true);
}

//BotonAyuda
void Ventana::BotonAyuda(wxCommandEvent& WXUNUSED(event))
{
  wxMessageBox(wxT("Lea el archivo Manual.pdf, que se encuentra dentro del directorio en el que se encuentra el ejecutable de GUDUX"), wxT("GUDUX"), wxOK | wxICON_INFORMATION, this);

}

//BotonInformacion
void Ventana::BotonInformacion(wxCommandEvent& WXUNUSED(event))
{


  wxString texto1="GUDUX (GNSS de la Universidad Distrital Francisco Jose de Caldas) es una aplicación desarrollada por";
  wxString texto2="David Monroy Machado como proyecto de grado para optar el título de Ingeniero Catastral Y Geodesta.";
  wxString texto3="Esta aplicación obtiene las coordenadas e información estadística de las mismas en un archivo por ";
  wxString texto4="medio de los archivos RINEX de un punto ingresados.";

  salidaInfo = new wxDialog(this, -1, wxT("Información Gudux v1.0"),wxDefaultPosition,wxSize(710,170), wxDEFAULT_DIALOG_STYLE,wxT("cajaDialogo"));
 
  wxFont fuente(10, wxDEFAULT,wxNORMAL, wxBOLD);
  wxStaticText *aptEncabezado = new wxStaticText(salidaInfo, -1, wxT("Datos de la Aplicación GUDUX v1.0"), wxPoint(180,15), wxDefaultSize, wxALIGN_CENTRE,wxT("encabezado"));
  aptEncabezado->SetFont(fuente);


  wxStaticLine *aptLineaEstatica1 = new wxStaticLine(salidaDatos, wxID_ANY, wxPoint(25,50), wxSize(300,1));

  //**********************CUADRO DE DIALOGO PARA LA INFORMACION*************************

  //Nombres Coordenadas
  wxStaticText *aptTextoEstaticoInfo1 = new wxStaticText(salidaInfo, wxID_ANY, texto1, wxPoint(25,80));
  wxStaticText *aptTextoEstaticoInfo2 = new wxStaticText(salidaInfo, wxID_ANY, texto2, wxPoint(25,100));
  wxStaticText *aptTextoEstaticoInfo3 = new wxStaticText(salidaInfo, wxID_ANY, texto3, wxPoint(25,120));
  wxStaticText *aptTextoEstaticoInfo4 = new wxStaticText(salidaInfo, wxID_ANY, texto4, wxPoint(25,140));

  salidaInfo->Show(true);
 
}


//BotonCargueObservacionesRinex
void Ventana::BotonCargueObservacionesBaseRinex(wxCommandEvent& WXUNUSED(event))
{

  wxFileDialog *aptAbrirArchivo = new wxFileDialog(this, wxT("Seleccione un archivo de Observaciones RINEX"), wxEmptyString, wxEmptyString, wxT("Observaciones (*.*o)|*.*o| Observaciones (*.*O)|*.*O| Todos los Archivos (*.*)|*.*"), wxFD_OPEN, wxPoint(200, 200), wxSize(300,300), wxT("pdfObsRinexBaseObs"));
  if(aptAbrirArchivo->ShowModal() == wxID_OK)
    {
     
      nombreArchivo = aptAbrirArchivo->GetPath();
      mensajes = "El archivo que desea cargar es: ";
      mensajes += nombreArchivo;
      wxMessageBox(mensajes, wxT("GUDUX"), wxOK | wxICON_INFORMATION, this);
      aptCtrlTextoObservacionesBaseRinex->Clear();
      aptCtrlTextoObservacionesBaseRinex->AppendText(nombreArchivo);

    }

}

//BotonCargueNavegacionesRinex
void Ventana::BotonCargueNavegacionesBaseRinex(wxCommandEvent& WXUNUSED(event))
{

  wxFileDialog *aptAbrirArchivo = new wxFileDialog(this, wxT("Seleccione un archivo de Navegaciones RINEX"), wxEmptyString, wxEmptyString, wxT("Navegaaciones (*.*n)|*.*n|Navegaciones (*.*N)|*.*N|Todos los Archivos (*.*)|*.*"), wxFD_OPEN, wxPoint(200, 200), wxSize(300,300), wxT("pdfObsRinexBaseNav"));;
  if(aptAbrirArchivo->ShowModal() == wxID_OK)
    {
     
      nombreArchivo = aptAbrirArchivo->GetPath();

    }
  mensajes = "El archivo que desea cargar es: ";
  mensajes += nombreArchivo;
  wxMessageBox(mensajes, wxT("GUDUX"), wxOK | wxICON_INFORMATION, this);
  aptCtrlTextoNavegacionesBaseRinex->Clear();
  aptCtrlTextoNavegacionesBaseRinex->AppendText(nombreArchivo);

}

//BotonCargueMetereologioRinex
void Ventana::BotonCargueMetereologiaBaseRinex(wxCommandEvent& WXUNUSED(event))
{


  wxFileDialog *aptAbrirArchivo = new wxFileDialog(this, wxT("Seleccione un archivo de Metereología RINEX"), wxEmptyString, wxEmptyString, wxT("Metereología (*.*m)|*.*m|Metereología (*.*M)|*.*M|Todos los Archivos (*.*)|*.*"), wxFD_OPEN, wxPoint(200, 200), wxSize(300,300), wxT("pdfObsRinexBaseMet"));;
  if(aptAbrirArchivo->ShowModal() == wxID_OK)
    {
     
      nombreArchivo = aptAbrirArchivo->GetPath();

    }
  mensajes = "El archivo que desea cargar es: ";
  mensajes += nombreArchivo;
  wxMessageBox(mensajes, wxT("GUDUX"), wxOK | wxICON_INFORMATION, this);
  aptCtrlTextoMetereologiaBaseRinex->Clear();
  aptCtrlTextoMetereologiaBaseRinex->AppendText(nombreArchivo);


}

//******Botones para bucar archivos del rover**********

//BotonCargueObservacionesRoverRinex
void Ventana::BotonCargueObservacionesRoverRinex(wxCommandEvent& WXUNUSED(event))
{

  wxFileDialog *aptAbrirArchivo = new wxFileDialog(this, wxT("Seleccione un archivo de Observaciones RINEX"), wxEmptyString, wxEmptyString, wxT("Observaciones (*.*o)|*.*o| Observaciones (*.*O)|*.*O|Todos los Archivos (*.*)|*.*"), wxFD_OPEN, wxPoint(200, 200), wxSize(300,300), wxT("pdfObsRinexRoverObs"));;
  if(aptAbrirArchivo->ShowModal() == wxID_OK)
    {
     
      nombreArchivo = aptAbrirArchivo->GetPath();

    }
  mensajes = "El archivo que desea cargar es: ";
  mensajes += nombreArchivo;
  wxMessageBox(mensajes, wxT("GUDUX"), wxOK | wxICON_INFORMATION, this);
  aptCtrlTextoObservacionesRoverRinex->Clear();
  aptCtrlTextoObservacionesRoverRinex->AppendText(nombreArchivo);

}

//BotonCargueNavegacionesRoverRinex
void Ventana::BotonCargueNavegacionesRoverRinex(wxCommandEvent& WXUNUSED(event))
{

  wxFileDialog *aptAbrirArchivo = new wxFileDialog(this, wxT("Seleccione un archivo de Navegaciones RINEX"), wxEmptyString, wxEmptyString, wxT("Navegaciones (*.*n)|*.*n|Navegaciones (*.*N)|*.*N|Todos los Archivos (*.*)|*.*"), wxFD_OPEN, wxPoint(200, 200), wxSize(300,300), wxT("pdfObsRinexRoverNav"));;
  if(aptAbrirArchivo->ShowModal() == wxID_OK)
    {
     
      nombreArchivo = aptAbrirArchivo->GetPath();

    }
  mensajes = "El archivo que desea cargar es: ";
  mensajes += nombreArchivo;
  wxMessageBox(mensajes, wxT("GUDUX"), wxOK | wxICON_INFORMATION, this);
  aptCtrlTextoNavegacionesRoverRinex->Clear();
  aptCtrlTextoNavegacionesRoverRinex->AppendText(nombreArchivo);

}

//BotonCargueMetereologiaRoverRinex
void Ventana::BotonCargueMetereologiaRoverRinex(wxCommandEvent& WXUNUSED(event))
{


  wxFileDialog *aptAbrirArchivo = new wxFileDialog(this, wxT("Seleccione un archivo de Metereología RINEX"), wxEmptyString, wxEmptyString, wxT("Metereología (*.*m)|*.*o|Metereología (*.*M)|*.*M|Todos los Archivos (*.*)|*.*"), wxFD_OPEN, wxPoint(200, 200), wxSize(300,300), wxT("pdfObsRinexRoverMet"));
  if(aptAbrirArchivo->ShowModal() == wxID_OK)
    {
     
      nombreArchivo = aptAbrirArchivo->GetPath();

    }
  mensajes = "El archivo que desea cargar es: ";
  mensajes += nombreArchivo;
  wxMessageBox(mensajes, wxT("GUDUX"), wxOK | wxICON_INFORMATION, this);
  aptCtrlTextoMetereologiaRoverRinex->Clear();
  aptCtrlTextoMetereologiaRoverRinex->AppendText(nombreArchivo);

}


void Ventana::BotonGuardarReporte(wxCommandEvent& WXUNUSED(event))
{

  wxFileDialog *aptSalvarArchivo = new wxFileDialog(this, wxT("Seleccione una dirección para almacenar el reporte"), wxEmptyString, wxEmptyString, wxT("Reportes (*.log)|*.log|Todos los Archivos (*.*)|*.*"), wxFD_SAVE, wxPoint(200, 200), wxSize(300,300), wxT("pdfSalidaReporte"));
  if(aptSalvarArchivo->ShowModal() == wxID_OK)
    {

      nombreArchivo = aptSalvarArchivo->GetPath();
    }

  mensajes = "El nombre del archivo seleccionado es: ";
  mensajes += nombreArchivo;
  wxMessageBox(mensajes, wxT("GUDUX"), wxOK | wxICON_INFORMATION, this);
  aptCtrlTextoArchivoSalida->Clear();
  aptCtrlTextoArchivoSalida->AppendText(nombreArchivo);
}

void Ventana::BotonProcesar(wxCommandEvent& WXUNUSED(event))
{

try
  {//inicio try
    //Variable que indica para el encabezado del archivo
    x = 1;


    //Cargue de los archivos RINEX
    archivosRinexBase->CargarObs(aptCtrlTextoObservacionesBaseRinex->GetValue());
    archivosRinexBase->CargarNav(aptCtrlTextoNavegacionesBaseRinex->GetValue());
    
    //Test a los archivos
    ajusteCoordenadas.testArchivos(archivosRinexBase); 

    //Ajuste a los datos de los archivos
    ajusteCoordenadas.ajusteDatosRinex(archivosRinexBase);
    

    //Coordenadas geocentricas preliminares
    xBase = ajusteCoordenadas.PromedioCoordenadaX();
    yBase = ajusteCoordenadas.PromedioCoordenadaY();
    zBase = ajusteCoordenadas.PromedioCoordenadaZ();

    //Coordendas geodesicas geocentricas
    latitudBase << ajusteCoordenadas.PromedioLatitud();
    longitudBase << ajusteCoordenadas.PromedioLongitud();
    alturaBase << ajusteCoordenadas.PromedioAltura();

    //*****************Informacion estadistica base******************

    //Varianzas coordenadas geodesicas
    ajusteCoordenadas.VarianzaLatitud();
    ajusteCoordenadas.VarianzaLongitud();
    ajusteCoordenadas.VarianzaAltura();

    //Varianzas coodenadas cartesianas
    ajusteCoordenadas.VarianzaX();
    ajusteCoordenadas.VarianzaY();
    ajusteCoordenadas.VarianzaZ();

    //Desviaciones coordenadas geodesicas
    ajusteCoordenadas.DesviacionEstandarLatitud();
    ajusteCoordenadas.DesviacionEstandarLongitud();
    ajusteCoordenadas.DesviacionEstandarAltura();

    //Desviaciones coordenadas cartesianas
    ajusteCoordenadas.DesviacionEstandarX();
    ajusteCoordenadas.DesviacionEstandarY();
    ajusteCoordenadas.DesviacionEstandarZ();

    //Calculo de los deltas de las coordenadas para la estacion Base
    ajusteCoordenadas.CorreccionesDiferenciales(aptCtrlTextoCoordenadaXBase->GetValue(), aptCtrlTextoCoordenadaYBase->GetValue(), aptCtrlTextoCoordenadaZBase->GetValue());

    //Coordenadas de la base corregidas
    xBase = ajusteCoordenadas.CoordenadaCorregidaX();
    yBase = ajusteCoordenadas.CoordenadaCorregidaY();
    zBase = ajusteCoordenadas.CoordenadaCorregidaZ();

    coordenadaXBase << xBase;
    coordenadaYBase << yBase;
    coordenadaZBase << zBase;

    //ajsutes formato numero
    coordenadaXBase.Printf(wxT("%lf"),xBase);
    coordenadaYBase.Printf(wxT("%lf"),yBase);
    coordenadaZBase.Printf(wxT("%lf"),zBase);
    latitudBase.Printf(wxT("%lf"),ajusteCoordenadas.PromedioLatitud());
    longitudBase.Printf(wxT("%lf"),ajusteCoordenadas.PromedioLongitud());
    alturaBase.Printf(wxT("%lf"),ajusteCoordenadas.PromedioAltura());

    ajusteCoordenadas.CrearArchivoReporte(aptCtrlTextoArchivoSalida->GetValue(), x);

    x++;

    //**************************Datos del rover*******************

    archivosRinexRover->CargarObs(aptCtrlTextoObservacionesRoverRinex->GetValue());
    archivosRinexRover->CargarNav(aptCtrlTextoNavegacionesRoverRinex->GetValue());


    //Test a los archivos
    ajusteCoordenadas.testArchivos(archivosRinexRover);

    //Ajuste a los datos de los archivos
    ajusteCoordenadas.ajusteDatosRinex(archivosRinexRover);

    //Calculo de las coordendas de punto rover
    xRover = ajusteCoordenadas.PromedioCoordenadaX();
    yRover = ajusteCoordenadas.PromedioCoordenadaY();
    zRover = ajusteCoordenadas.PromedioCoordenadaZ();
 
    //Correccion de las coordenadas a partir de la información ingresada
    xRover = ajusteCoordenadas.CoordenadaCorregidaX();
    yRover = ajusteCoordenadas.CoordenadaCorregidaY();
    zRover = ajusteCoordenadas.CoordenadaCorregidaZ();

    coordenadaXRover << xRover;
    coordenadaYRover << yRover;
    coordenadaZRover << zRover;

    //cout << "xRover " << coordenadaXRover << endl;

    latitudRover << ajusteCoordenadas.PromedioLatitud();
    longitudRover << ajusteCoordenadas.PromedioLongitud();
    alturaRover << ajusteCoordenadas.PromedioAltura();

    ajusteCoordenadas.VarianzaX();
    ajusteCoordenadas.VarianzaY();
    ajusteCoordenadas.VarianzaZ();
    
    ajusteCoordenadas.VarianzaLatitud();
    ajusteCoordenadas.VarianzaLongitud();
    ajusteCoordenadas.VarianzaAltura();
 
    ajusteCoordenadas.DesviacionEstandarX();
    ajusteCoordenadas.DesviacionEstandarY();
    ajusteCoordenadas.DesviacionEstandarZ();
    
    ajusteCoordenadas.DesviacionEstandarLatitud();
    ajusteCoordenadas.DesviacionEstandarLongitud();
    ajusteCoordenadas.DesviacionEstandarAltura();
    
    //ajsutes formato numero
    coordenadaXRover.Printf(wxT("%lf"),xRover);
    coordenadaYRover.Printf(wxT("%lf"),yRover);
    coordenadaZRover.Printf(wxT("%lf"),zRover);
    latitudRover.Printf(wxT("%lf"),ajusteCoordenadas.PromedioLatitud());
    longitudRover.Printf(wxT("%lf"),ajusteCoordenadas.PromedioLongitud());
    alturaRover.Printf(wxT("%lf"),ajusteCoordenadas.PromedioAltura());
    
    //Calcula el vector entre los puntos...
    cout << "El vector calculado tiene magnitud: " << ajusteCoordenadas.Vector(xBase, xRover, yBase, yRover, zBase, zRover) << endl;

    longitudVector << ajusteCoordenadas.Vector(xBase, xRover, yBase, yRover, zBase, zRover);
    


    //Enviando al archivo de texto
    ajusteCoordenadas.CrearArchivoReporte(aptCtrlTextoArchivoSalida->GetValue(), x);
    
    //Enviando datos al achivo
    cout << "Enviando datos al archivo: "<< aptCtrlTextoArchivoSalida->GetValue()<<" ...\n";

    wxMessageBox(wxT("Ajuste realizado"), wxT("GUDUX"), wxOK | wxICON_EXCLAMATION, this);
 

    //Dialogo con las coordenadas finales
    salidaDatos = new wxDialog(this, -1, wxT("Coordenadas Gudux v1.0"),wxDefaultPosition,wxSize(350,450), wxDEFAULT_DIALOG_STYLE,wxT("cajaDialogo"));
 
  wxFont fuente(10, wxDEFAULT,wxNORMAL, wxBOLD);
  wxStaticText *aptEncabezado = new wxStaticText(salidaDatos, -1, wxT("Coordenadas Obtenidas"), wxPoint(30,15), wxDefaultSize, wxALIGN_CENTRE,wxT("encabezado"));
  aptEncabezado->SetFont(fuente);



  wxStaticLine *aptLineaEstatica1 = new wxStaticLine(salidaDatos, wxID_ANY, wxPoint(25,50), wxSize(300,1));

  //**********************BASE*************************

  //Nombres Coordenadas
  wxStaticText *aptTextoEstatico1 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Datos de la Base:"), wxPoint(25,80));
  wxStaticText *aptTextoEstatico2 = new wxStaticText(salidaDatos, wxID_ANY, wxT("X(m):"), wxPoint(25,100));
  wxStaticText *aptTextoEstatico3 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Y(m):"), wxPoint(25,120));
  wxStaticText *aptTextoEstatico4 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Z(m):"), wxPoint(25,140));
  wxStaticText *aptTextoEstatico5 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Latitud:"), wxPoint(25,160));
  wxStaticText *aptTextoEstatico6 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Longitud:"), wxPoint(25,180));
  wxStaticText *aptTextoEstatico7 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Altura:"), wxPoint(25,200));
  //Numeros Coordenadas
  wxStaticText *aptTextoEstatico8 = new wxStaticText(salidaDatos, wxID_ANY, coordenadaXBase, wxPoint(190, 100), wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTtextoEstatico9 = new wxStaticText(salidaDatos, wxID_ANY, coordenadaYBase, wxPoint(190, 120), wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTextoEstatico10 = new wxStaticText(salidaDatos, wxID_ANY, coordenadaZBase, wxPoint(190, 140), wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTextoEstatico11 = new wxStaticText(salidaDatos, wxID_ANY, latitudBase, wxPoint(190, 160), wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTtextoEstatico12 = new wxStaticText(salidaDatos, wxID_ANY, longitudBase, wxPoint(190, 180), wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTextoEstatico13 = new wxStaticText(salidaDatos, wxID_ANY, alturaBase, wxPoint(190, 200), wxSize(120, -1), wxALIGN_RIGHT);

  //Segunda Linea
  wxStaticLine *aptLineaEstatica2 = new wxStaticLine(salidaDatos, wxID_ANY, wxPoint(25,230), wxSize(300,1));

  //***********************ROVER*****************************************************

  //Nombres Coordenadas
  wxStaticText *aptTextoEstatico14 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Datos del Rover:"), wxPoint(25,260));
  wxStaticText *aptTextoEstatico15 = new wxStaticText(salidaDatos, wxID_ANY, wxT("X(m):"), wxPoint(25,280));
  wxStaticText *aptTextoEstatico16 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Y(m):"), wxPoint(25,300));
  wxStaticText *aptTextoEstatico17 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Z(m):"), wxPoint(25,320));
  wxStaticText *aptTextoEstatico18 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Latitud:"), wxPoint(25,340));
  wxStaticText *aptTextoEstatico19 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Longitud:"), wxPoint(25,360));
  wxStaticText *aptTextoEstatico20 = new wxStaticText(salidaDatos, wxID_ANY, wxT("Altura:"), wxPoint(25,380));


  //Numeros Coordenadas
  wxStaticText *aptTextoEstatico21 = new wxStaticText(salidaDatos, wxID_ANY, coordenadaXRover, wxPoint(190, 280),wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTtextoEstatico22 = new wxStaticText(salidaDatos, wxID_ANY, coordenadaYRover, wxPoint(190, 300),wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTextoEstatico23 = new wxStaticText(salidaDatos, wxID_ANY, coordenadaZRover, wxPoint(190, 320), wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTextoEstatico24 = new wxStaticText(salidaDatos, wxID_ANY, latitudRover, wxPoint(190, 340), wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTtextoEstatico25 = new wxStaticText(salidaDatos, wxID_ANY, longitudRover, wxPoint(190, 360), wxSize(120, -1), wxALIGN_RIGHT);
  wxStaticText *aptTextoEstatico26 = new wxStaticText(salidaDatos, wxID_ANY, alturaRover, wxPoint(190, 380), wxSize(120, -1), wxALIGN_RIGHT);



  //Tercera Linea
  wxStaticLine *aptLineaEstatica3 = new wxStaticLine(salidaDatos, wxID_ANY, wxPoint(25,410), wxSize(300,1));



  wxStaticText *aptSuma = new wxStaticText(this, wxID_ANY, wxT("164 102 000"), wxPoint(220,280));

  wxFont fuenteSuma = aptSuma->GetFont();
  cout << "archivo creado"<<endl;
  cout << "Por favor dirigase a la ruta " << aptCtrlTextoArchivoSalida->GetValue() << " para observar los resultados obtenidos" << endl;



  aptSuma->SetFont(fuenteSuma);
  this->Centre();

  salidaDatos->ShowModal();
  salidaDatos->Destroy();


  }//fin try
 catch(Exception& error)
   {
     cerr << "Existe un error en el archivo: " << error << endl;
     //return 1;
   }
 catch(...)
   {
     cerr << "Error desconocido " << endl;
     //return 1;
   }
// delete archivosRinexBase;
// delete archivosRinexRover;
 
 x = 0;
}

